package net.gorry.eyefikey;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.concurrent.CountDownLatch;

import javax.xml.parsers.SAXParserFactory;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.os.SystemClock;
import android.util.Log;

/**
 * @author gorry
 *
 */
public class eyefiKey {
	private static final String TAG = "eyefiKey";
	private static final boolean V = false;
	private static final boolean D = true;//false;
	private static final boolean I = true;//false;

	private final static String API_URL= "https://api.eye.fi/api/rest/partners/1.0/?";
	private final static String API_URL_SIG = "f01a85f69e147b6335c1381cb9d9c288";
	private final static String API_KEY = "57b3f5813f3d9a783b8a4456edc13328";
	
	private String mUserName = null;
	private String mPassword = null;
	
	private int mNumDevice;
	private ArrayList<String> mDeviceKey = new ArrayList<String>();
	private ArrayList<String> mDeviceMac = new ArrayList<String>();
	private ArrayList<String> mDeviceId = new ArrayList<String>();
	private ArrayList<String> mDeviceName = new ArrayList<String>();
	private ArrayList<String> mDeviceBrand = new ArrayList<String>();
	private ArrayList<String> mDeviceType = new ArrayList<String>();

	private ProgressDialog mPD;

	/**
	 * コンストラクタ
	 */
	public eyefiKey() {
		//
	}

	private String MD5Hex(byte[] md5) {
		String str = "";
		for (int i=0; i<md5.length; i++) {
			str = str + String.format("%02x", md5[i]);
		}
		return str; 
	}
	
	private String urlAuth(String user, String pass) {
		String url = API_URL;
		String sig = API_URL_SIG;
		TreeMap<String, String> m = new TreeMap<String, String>();
		m.put("api_key", API_KEY);
		m.put("method", "auth.login");
		m.put("Login", user);
		m.put("Password", pass);
		Iterator<String> it = m.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			String value = m.get(key);
			sig = sig + key + value;
			url = url + key + "=" + value + "&";
		}

		MessageDigest md;
		try {
			md = MessageDigest.getInstance("MD5");
			byte[] b = sig.getBytes();
			md.update(b, 0, b.length); 
			return url + "api_sig=" + MD5Hex(md.digest());
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}

	private String urlGetDevices(String token) {
		Date date = new Date();
		String url = API_URL;
		String sig = API_URL_SIG;
		TreeMap<String, String> m = new TreeMap<String, String>();
		m.put("api_key", API_KEY);
		m.put("method", "devices.get");
		m.put("auth_token", token);
		m.put("call_id", String.valueOf(date.getTime()));
		Iterator<String> it = m.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			String value = m.get(key);
			sig = sig + key + value;
			url = url + key + "=" + value + "&";
		}

		MessageDigest md;
		try {
			md = MessageDigest.getInstance("MD5");
			byte[] b = sig.getBytes();
			md.update(b, 0, b.length); 
			return url + "api_sig=" + MD5Hex(md.digest());
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}

	private String urlGetUploadKey(String token, String mac, String id) {
		Date localDate = new Date();
		String url = API_URL;
		String sig = API_URL_SIG;
		TreeMap<String, String> m = new TreeMap<String, String>();
		m.put("Mac", mac);
		m.put("DesktopID", id);
		m.put("api_key", API_KEY);
		m.put("method", "devices.setDesktop");
		m.put("auth_token", token);
		m.put("call_id", String.valueOf(localDate.getTime()));
		Iterator<String> it = m.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			String value = m.get(key);
			sig = sig + key + value;
			url = url + key + "=" + value + "&";
		}

		MessageDigest md;
		try {
			md = MessageDigest.getInstance("MD5");
			byte[] b = sig.getBytes();
			md.update(b, 0, b.length); 
			return url + "api_sig=" + MD5Hex(md.digest());
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}

	private String xmlGetHttps(String url) {
		final Object o = new Object();
		final HttpGet get = new HttpGet(url);
		final DefaultHttpClient client = new DefaultHttpClient();
		final String[] retxml = new String[1];
		retxml[0] = null;

		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(client.execute(get).getEntity().getContent()));
			StringBuffer buf = new StringBuffer();
			while (true) {
				String line = reader.readLine();
				if (line == null) {
					retxml[0] = buf.toString();
					break;
				}
				buf.append(line);
			}
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return retxml[0];
	}

	private eyefiKeyXmlApi decodeXml(String xml) {
		XMLReader reader = null;
		eyefiKeyXmlApi guku = null;

		try {
			reader = SAXParserFactory.newInstance().newSAXParser().getXMLReader();
			guku = new eyefiKeyXmlApi();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		try {
			reader.setContentHandler(guku);
			reader.parse(new InputSource(new StringReader(xml)));
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		return guku;
		
	}

	/**
	 * eye.fiサーバから「アカウントに登録されたデバイスの情報」を取得する
	 * @return デバイス数（負でエラー）
	 */
	public int doGetKey() {
		eyefiKeyXmlApi userInfo;
		String token;

		eyefiKeyXmlApi devInfo;

		eyefiKeyXmlApi devParam;
		String uploadKey;

		String url;
		String xml;

		mNumDevice = 0;
		mDeviceId.clear();
		mDeviceMac.clear();
		mDeviceKey.clear();

		// トークン取得
		if (D) Log.d(TAG, "** Get Token: start");
		url = urlAuth(mUserName, mPassword);
		if (D) Log.d(TAG, "url=["+url+"]");
		xml = xmlGetHttps(url);
		if (D) Log.d(TAG, "xml=["+xml+"]");
		if (xml == null) {
			Log.e(TAG, "Get Token: xml=null");
			return -1;
		}
		userInfo = decodeXml(xml);
		if (userInfo == null) {
			Log.e(TAG, "Get Token: userInfo=null");
			return -2;
		}
		if (userInfo.mError) {
			Log.e(TAG, "Get Token: userInfo=error: message=["+userInfo.mMessage+"]");
			return -3;
		}
		token = userInfo.mAuthToken;
		if (I) Log.i(TAG, "token=["+token+"]");
		if (token == null) {
			Log.e(TAG, "Get Token: token=null");
			return -4;
		}
		if (D) Log.d(TAG, "** Get Token: end");
		
		// デバイスリスト取得
		if (D) Log.d(TAG, "** Get Device Info: start");
		url = urlGetDevices(token);
		if (D) Log.d(TAG, "url=["+url+"]");
		xml = xmlGetHttps(url);
		if (D) Log.d(TAG, "xml=["+xml+"]");
		if (xml == null) {
			Log.e(TAG, "Get Device Info: xml=null");
			return -1;
		}
		devInfo = decodeXml(xml);
		if (devInfo == null) {
			Log.e(TAG, "Get Device Info: devInfo=null");
			return -5;
		}
		if (devInfo.mError) {
			Log.e(TAG, "Get Device Info: devInfo=error");
			return -6;
		}
		int devicenum = devInfo.mNumDevice;
		if (I) Log.i(TAG, "humber of device="+devicenum);

		for (int i=0; i<devicenum; i++) {
			String mac = devInfo.mMac.get(i);
			String id = devInfo.mDesktopId.get(i);
			url = urlGetUploadKey(token, mac, id);
			if (D) Log.d(TAG, "url=["+url+"]");
			xml = xmlGetHttps(url);
			if (D) Log.d(TAG, "xml=["+xml+"]");
			if (xml == null) {
				Log.e(TAG, "Get Device ["+i+"] Param: xml=null");
				continue;
			}
			devParam = decodeXml(xml);
			if (devParam == null) {
				Log.e(TAG, "Get Device["+i+"] Param: devParam=null");
				continue;
			}
			if (devInfo.mError) {
				Log.e(TAG, "Get Device["+i+"] Param: devParam=error");
				continue;
			}
			uploadKey = devParam.mUploadKey;
			if (I) Log.i(TAG, "dev "+i+": mac=["+mac+"], id=["+id+"], uploadKey=["+uploadKey+"]");
			mDeviceId.add(id);
			mDeviceMac.add(mac);
			mDeviceName.add(devInfo.mName.get(i));
			mDeviceBrand.add(devInfo.mBrand.get(i));
			mDeviceType.add(devInfo.mType.get(i));
			mDeviceKey.add(uploadKey);
		}
		mNumDevice = mDeviceId.size();
		if (I) Log.i(TAG, "number of registered device="+mNumDevice);

		if (D) Log.d(TAG, "** Get Device Info: end");

		return mNumDevice;
	}

	/**
	 * eye.fiサーバへ送信するユーザー名の設定
	 * @param user ユーザー名
	 */
	public void setUserName(String user) {
		mUserName = user;
	}

	/**
	 * eye.fiサーバへ送信するパスワードの設定
	 * @param pass パスワード
	 */
	public void setPassword(String pass) {
		mPassword = pass;
	}

	/**
	 * eye.fiサーバから取得した「アカウントに登録されたデバイス数」を返す
	 * @return デバイス数
	 */
	public int numDevice() {
		return mNumDevice;
	}

	/**
	 * 指定番号のデバイスIDを返す
	 * @param i デバイス番号
	 * @return デバイスID
	 */
	public String deviceId(int i) {
		return mDeviceId.get(i);
	}

	/**
	 * 指定番号のデバイスMacアドレス（01-23-45-67-89-ab）を返す
	 * @param i デバイス番号
	 * @return デバイスMacアドレス
	 */
	public String deviceMac(int i) {
		return mDeviceMac.get(i);
	}

	/**
	 * 指定番号のデバイス名称を返す
	 * @param i デバイス番号
	 * @return デバイス名称
	 */
	public String deviceName(int i) {
		return mDeviceName.get(i);
	}

	/**
	 * 指定番号のデバイスブランドを返す
	 * @param i デバイス番号
	 * @return デバイスブランド
	 */
	public String deviceBrand(int i) {
		return mDeviceBrand.get(i);
	}

	/**
	 * 指定番号のデバイスタイプを返す
	 * @param i デバイス番号
	 * @return デバイスUploadKey
	 */
	public String deviceType(int i) {
		return mDeviceType.get(i);
	}

	/**
	 * 指定番号のデバイスUploadKeyを返す
	 * @param i デバイス番号
	 * @return デバイスUploadKey
	 */
	public String deviceKey(int i) {
		return mDeviceKey.get(i);
	}

}
