package net.gorry.eyefikey;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;

public class eyefiKeyTask extends AsyncTask <Integer, Integer, Integer> {
	private static final String TAG = "eyefiKeyHandler";
	private static final boolean V = false;
	private static final boolean D = false;
	private static final boolean I = true;//false;

	private Context me;

	private ProgressDialog mPD;
	private eyefiKey mEyefiKey;
	private Runnable mHandler = null;

	public eyefiKeyTask(Context context) {
		mEyefiKey = new eyefiKey();
		me = context;
	}

	public void setHandler(Runnable r) {
		mHandler = r;
	}

	@Override
	protected void onPreExecute() {
		super.onPreExecute();
		mPD = new ProgressDialog(me);
		mPD.setTitle("Connecting");
		mPD.setMessage("Connecting to eye.fi Server...");
		mPD.setIndeterminate(true);
		mPD.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		mPD.show();
	}

	@Override
	protected Integer doInBackground(Integer... params) {
		return (Integer)mEyefiKey.doGetKey();
	}

	@Override
	protected void onProgressUpdate(Integer... progress) {
		//
	}

	@Override
	protected void onPostExecute(Integer result) {
		super.onPostExecute(result);
		mPD.dismiss();
		mPD = null;
		if (mHandler != null) {
			mHandler.run();
		}
	}

	/**
	 * eye.fiサーバへ送信するユーザー名の設定
	 * @param user ユーザー名
	 */
	public void setUserName(String user) {
		mEyefiKey.setUserName(user);
	}

	/**
	 * eye.fiサーバへ送信するパスワードの設定
	 * @param pass パスワード
	 */
	public void setPassword(String pass) {
		mEyefiKey.setPassword(pass);
	}

	/**
	 * eye.fiサーバから取得した「アカウントに登録されたデバイス数」を返す
	 * @return デバイス数
	 */
	public int numDevice() {
		return mEyefiKey.numDevice();
	}

	/**
	 * 指定番号のデバイスIDを返す
	 * @param i デバイス番号
	 * @return デバイスID
	 */
	public String deviceId(int i) {
		return mEyefiKey.deviceId(i);
	}

	/**
	 * 指定番号のデバイスMacアドレス（01-23-45-67-89-ab）を返す
	 * @param i デバイス番号
	 * @return デバイスMacアドレス
	 */
	public String deviceMac(int i) {
		return mEyefiKey.deviceMac(i);
	}

	/**
	 * 指定番号のデバイスUploadKeyを返す
	 * @param i デバイス番号
	 * @return デバイスUploadKey
	 */
	public String deviceKey(int i) {
		return mEyefiKey.deviceKey(i);
	}

	/**
	 * 指定番号のデバイス名称を返す
	 * @param i デバイス番号
	 * @return デバイス名称
	 */
	public String deviceName(int i) {
		return mEyefiKey.deviceName(i);
	}

	/**
	 * 指定番号のデバイスブランドを返す
	 * @param i デバイス番号
	 * @return デバイスブランド
	 */
	public String deviceBrand(int i) {
		return mEyefiKey.deviceBrand(i);
	}

	/**
	 * 指定番号のデバイスタイプを返す
	 * @param i デバイス番号
	 * @return デバイスタイプ
	 */
	public String deviceType(int i) {
		return mEyefiKey.deviceType(i);
	}
}
