package net.gorry.eyefikey;

import java.util.ArrayList;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class eyefiKeyXmlApi extends DefaultHandler {
	private static final String TAG = "eyefiKeyXmlApi";
	private static final boolean V = false;
	private static final boolean D = true;//false;
	private static final boolean I = true;//false;

	private static final int STATE_AUTOTOKEN = 1;
	private static final int STATE_MESSAGE = 2;
	private static final int STATE_MAC = 3;
	private static final int STATE_DESKTOPID = 4;
	private static final int STATE_NAME = 5;
	private static final int STATE_BRAND = 6;
	private static final int STATE_TYPE = 7;
	private static final int STATE_UPLOADKEY = 8;
	private int mState = 0;

	public boolean mError = false;

	public String mAuthToken = null;
	public int mNumDevice = 0;
	public String mMessage = null;
	public ArrayList<String> mDesktopId = new ArrayList();
	public ArrayList<String> mMac = new ArrayList();
	public ArrayList<String> mName = new ArrayList();
	public ArrayList<String> mBrand = new ArrayList();
	public ArrayList<String> mType = new ArrayList();
	public String mUploadKey = null;

	@Override
	public void characters(char[] ch, int start, int length) {
		switch (this.mState) {
			default:
				break;
			case STATE_AUTOTOKEN:
				this.mAuthToken = new String(ch, start, length);
				break;
			case STATE_MESSAGE:
				this.mMessage = new String(ch, start, length);
				break;
			case STATE_MAC:
				this.mMac.add(new String(ch, start, length));
				break;
			case STATE_DESKTOPID:
				this.mDesktopId.add(new String(ch, start, length));
				break;
			case STATE_NAME:
				this.mName.add(new String(ch, start, length));
				break;
			case STATE_BRAND:
				this.mBrand.add(new String(ch, start, length));
				break;
			case STATE_TYPE:
				this.mType.add(new String(ch, start, length));
				break;
			case STATE_UPLOADKEY:
				this.mUploadKey = new String(ch, start, length);
				break;
		}
	}

	@Override
	public void endDocument() throws SAXException {
		//
	}

	@Override
	public void endElement(String uri, String localName, String qName) throws SAXException {
		this.mState = 0;
	}

	@Override
	public void startDocument() throws SAXException {
		//
	}

	@Override
	public void startElement(String uri, String localName, String qName, Attributes atr) throws SAXException {
		if (localName.equals("AuthToken")) {
			this.mState = STATE_AUTOTOKEN;
			return;
		}
		if (localName.equals("Device")) {
			this.mNumDevice = (1 + this.mNumDevice);
			return;
		}
		if (localName.equals("Message")) {
			this.mState = STATE_MESSAGE;
			return;
		}
		if (localName.equals("Error")) {
			this.mError = true;
			return;
		}
		if (localName.equals("Mac")) {
			this.mState = STATE_MAC;
			return;
		}
		if (localName.equals("DesktopId")) {
			this.mState = STATE_DESKTOPID;
			return;
		}
		if (localName.equals("Name")) {
			this.mState = STATE_NAME;
			return;
		}
		if (localName.equals("Brand")) {
			this.mState = STATE_BRAND;
			return;
		}
		if (localName.equals("Type")) {
			this.mState = STATE_TYPE;
			return;
		}
		if (localName.equals("UploadKey")) {
			this.mState = STATE_UPLOADKEY;
			return;
		}
	}
}
